# Literate Pandoc

Literate Pandoc is a [Pandoc filter] written in [Lua] for [literate] and
[natural] programming (LiNP or just Linp), i.e.: "[Programming \[...\] as the
process of creating works of literature][1]".

## Requirements

-   [Pandoc]

## Install

1.  Go to [Releases].
2.  Download the latest version of `linp.lua`.
3.  Done!

## Usage

With `linp.lua` downloaded and Pandoc installed, do:

    pandoc -L PATH/TO/linp.lua -t FORMAT DOC

For example, if `DOC` is `source.md` and the output `FORMAT` is HTML, do:

    pandoc -L PATH/TO/linp.lua -t html source.md

## Manual

Learn how to do LiNP [here].

## Develop

Clone this repo:

    git clone https://git.cuates.net/perro/literate-pandoc.git

Enter the repo:

    cd literate-pandoc

Inside, do the tests:

    sh scripts/test.sh

For other kind of tests, do:

    sh scripts/test.sh -h

Contribute!

## Acknowledgments

This wouldn't be possible without these projects and their collaborators:

-   [Pandoc][]: universal document converter and parser; handles the
    requirements for LiNP.
-   [Lua][]: programming language; enables LiNP.
-   [Fennel][]: [Lisp] dialect with full Lua compatibility; allows to go from
    LiNP to Lisp or Lua.

## License

Literate Pandoc is under [GPLv3].

Happy hacking :)

  [Pandoc filter]: https://pandoc.org/lua-filters.html
  [Lua]: https://www.lua.org/
  [literate]: https://en.wikipedia.org/wiki/Literate_programming
  [natural]: https://en.wikipedia.org/wiki/Natural-language_programming
  [1]: https://web.archive.org/web/20170605163729/http://www.desy.de/user/projects/LitProg/Philosophy.html
  [Pandoc]: https://pandoc.org/
  [Releases]: https://git.cuates.net/perro/literate-pandoc/releases
  [here]: https://git.cuates.net/perro/literate-pandoc/src/branch/no-masters/man/README.md
  [Fennel]: https://fennel-lang.org
  [Lisp]: https://en.wikipedia.org/wiki/Lisp_(programming_language)
  [GPLv3]: https://git.cuates.net/perro/literate-pandoc/src/branch/no-masters/LICENSE.txt
